<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_StockReposicionDetalle.xml */
/* Generado: 2020-08-18 04:21:28 */

/* Mantenimiento de los registros de la tabla MST_StockReposicionDetalle */
abstract class BaseMST_StockReposicionDetalleDP extends MST_StockReposicionDetalleBV
{
    /* Constructor ( Establece los valores desde un objeto MST_StockReposicionDetalleBN ) */
    public function __construct( MST_StockReposicionDetalleBN $o_MST_StockReposicionDetalleBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_StockReposicionDetalleBN ) )
        {
            $this->setByBN( $o_MST_StockReposicionDetalleBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_StockReposicionDetalleBN */
    public function setByBN( MST_StockReposicionDetalleBN $o_MST_StockReposicionDetalleBN )
    {
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_MST_StockReposicionDetalleBN->getIdCompania() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_MST_StockReposicionDetalleBN->getIdSucursal() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_MST_StockReposicionDetalleBN->getIdAlmacen() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getIdPersona() ) )
        {
            $this->setIdPersona( $o_MST_StockReposicionDetalleBN->getIdPersona() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getIdItem() ) )
        {
            $this->setIdItem( $o_MST_StockReposicionDetalleBN->getIdItem() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_StockReposicionDetalleBN->getEstado() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getStockMinimo() ) )
        {
            $this->setStockMinimo( $o_MST_StockReposicionDetalleBN->getStockMinimo() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getStockMaximo() ) )
        {
            $this->setStockMaximo( $o_MST_StockReposicionDetalleBN->getStockMaximo() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getStockActual() ) )
        {
            $this->setStockActual( $o_MST_StockReposicionDetalleBN->getStockActual() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_StockReposicionDetalleBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_StockReposicionDetalleBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_StockReposicionDetalleBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_StockReposicionDetalleBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_StockReposicionDetalleFN = new MST_StockReposicionDetalleFN();
        $o_MST_StockReposicionDetalleBN = $o_MST_StockReposicionDetalleFN->selectByPk( $this->getIdCompania(), $this->getIdSucursal(), $this->getIdAlmacen(), $this->getIdPersona(), $this->getIdItem() );
        if ( is_null( $o_MST_StockReposicionDetalleBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_StockReposicionDetalle ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPersona";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMinimo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockMinimo";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockMinimo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMaximo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockMaximo";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockMaximo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockActual() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockActual";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockActual()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_StockReposicionDetalle SET ";
            $s_Separator = "";
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMinimo() ) )
            {
                $s_SQLQuery .= $s_Separator."StockMinimo = ".$this->getStockMinimo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMaximo() ) )
            {
                $s_SQLQuery .= $s_Separator."StockMaximo = ".$this->getStockMaximo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockActual() ) )
            {
                $s_SQLQuery .= $s_Separator."StockActual = ".$this->getStockActual()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdCompania = ".$this->getIdCompania()." AND  IdSucursal = ".$this->getIdSucursal()." AND  IdAlmacen = '".$this->getIdAlmacen()."' AND  IdPersona = ".$this->getIdPersona()." AND  IdItem = '".$this->getIdItem()."';";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_StockReposicionDetalle WHERE  IdCompania = ".$this->getIdCompania()." AND  IdSucursal = ".$this->getIdSucursal()." AND  IdAlmacen = '".$this->getIdAlmacen()."' AND  IdPersona = ".$this->getIdPersona()." AND  IdItem = '".$this->getIdItem()."';";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>